import json
from mapnamindsdk.Rest import Rest
from mapnamindsdk import Constants


class Mapper:
    __instance = None

    SignalMapper = None

    def __init__(self):
        """ Virtually private constructor. """
        if Mapper.__instance != None:
            raise Exception("This class is a singleton!")
        else:
            Mapper.SignalMapper = Mapper.getMapper()
            Mapper.__instance = self


    @staticmethod
    def getInstance():

        if Mapper.__instance == None:
            Mapper()
        return Mapper.__instance

    @staticmethod
    def getMapper():
        try:
            request = Rest(
                f'http://{Constants.GATEWAY_SERVER_IP}:{Constants.GATEWAY_PORT}', path='/signal/getmapper')
            dictResponse = request.get(get_json=True)

            dictResult = {}
            for signal in dictResponse:
                if dictResponse[signal]['plantId'] == 3:
                    dictResult[dictResponse[signal]['signalName']] = signal

        except Exception as e:
            print(str(e))
            return None
        return dictResult