import json
from mapnamindsdk.Mapper import Mapper as mapper
import mapnamindsdk.Constants as Constants
# from http.client import IncompleteRead
import pandas as pd
from mapnamindsdk.Rest import Rest as Rest


import time

from mapnamindsdk.Mind import Mind


class Offline(Mind):

    @staticmethod
    def getUdsValue(signalNames, startDate, endDate, userId):

        Offline._validate(startDate)
        Offline._validate(endDate)

        try:
            body = {"signalNames": signalNames,
                    "startDate": startDate,
                    "endDate": endDate,
                    "userId": userId
                    }

            post_req = Rest(f'http://{Constants.GATEWAY_SERVER_IP}:{Constants.GATEWAY_PORT}',
                            path='/sdk/offline/getUsd', params=body)
            listResult = post_req.post()

            print(listResult)

            return listResult

        except KeyError as err:
            print("ERROR: Signal Name {} not found!\n".format(err))
        return None

    @staticmethod
    def getValue(signalNames, startDate, endDate, aggregation, interval, pageNumber=1, pageSize=1000):
        jsonResult = None
        global previous_json
        t = time.time()
        # while True and time.time() - t < 2:
        try:
                Offline._validate(startDate)
                Offline._validate(endDate)

                f = mapper.getInstance()

                # Get signalId for given signalName from the Mapper
                signalIDs = list(map(lambda x: int(f.SignalMapper[x]), signalNames))

                units = list(map(lambda x: int(x[0:2]), signalNames))

                # Request Body
                body = {"ids": signalIDs,
                        "units": units,
                        "from_date": startDate,
                        "to_date": endDate,
                        "agg": aggregation,
                        "interval": interval,
                        "page_size": pageSize,
                        "page_number": pageNumber
                        }

                # targetUrl = "http://" + Constants.SDK_SERVER_IP + ":" + Constants.SDK_PORT + "/offline/get"

                post_req = Rest(f'http://{Constants.GATEWAY_SERVER_IP}:{Constants.GATEWAY_PORT}',
                                path='/sdk/offline/get', params=body)
                jsonResult = post_req.post()

        except KeyError as err:
                print("ERROR: Signal Name {} not found!\n".format(err))

        df_result = Offline._convertJsonToDataFrame(jsonResult, signalNames)

        return df_result
        # return None

    @staticmethod
    def getValue2(signalNames, timeRanges: list, aggregation, interval, pageNumber=1, pageSize=1000) -> pd.DataFrame:
        final_result = pd.DataFrame([])
        # final_result_list=[]
        for range in timeRanges:
            startDate = range[0]
            endDate = range[1]
            df = Offline.getValue(signalNames, startDate=startDate, endDate=endDate, aggregation=aggregation,
                                  interval=interval, pageNumber=pageNumber, pageSize=pageSize)
            final_result = pd.concat([final_result, df])
            # final_result_list.append(df)

        return final_result

    @staticmethod
    def getLastValue(signalNames):
        return super(Offline, Offline).getValue(signalNames)